Snap install / remove failures aren't stopped in GNOME Software

Bug #1762427 reported by Evan on 2018-04-09
8
This bug affects 1 person
Affects Status Importance Assigned to Milestone
gnome-software (Ubuntu)
Undecided
Unassigned
Xenial
High
Unassigned
Artful
Undecided
Unassigned
Bionic
Undecided
Unassigned

Bug Description

[Impact]
Install / remove operations that fail don't show correctly in GNOME Software. Solution was to fix incorrect logic in snapd API code in GNOME software.

[Test Case]
1. Open GNOME Software
2. Start installing a snap
3. Cancel the operation from the command line (need to wait until install starts, but before it completes):
$ snap abort --last=install

Expected result:
Install stops and GNOME software show correct state

Observed result:
Install button still shows, but no progress occurs.

[Regression Potential]
Could create new bugs in async results.

Evan (ev) wrote :

The error:
$ snap watch 28
error: cannot perform the following tasks:
- Download snap "ora" (20) from channel "stable" (received an unexpected http response code (503) when trying to download https://068ed04f23.site.internapcdn.net/download-snap/UOherCuaihZSvX4eKrx7FqKHKah4TEqb_20.snap?t=2018-04-09T17:00:00Z&h=c26c77d52fc51a486bd96f38433104f9c5222b03)

Evan (ev) wrote :

The only relevant line in syslog:
2018/04/09 14:54:06.762039 api.go:1004: Installing snap "ora" revision unset

Robert Ancell (robert-ancell) wrote :

I'm guessing the trigger for this was the store / CDN failing? It downloads for me, so I'm not able to reproduce. Any download failure like this should report an error in GNOME Software, trying to think of another method to trigger this...

Robert Ancell (robert-ancell) wrote :

On code inspection, I think the snap support in gnome-software 3.20 doesn't handle async operation failures correctly.

description: updated
summary: - No feedback when snap installation fails
+ Snap install / remove failures aren't stopped in GNOME Software
Changed in gnome-software (Ubuntu):
status: New → Fix Committed
importance: Undecided → High
Changed in gnome-software (Ubuntu Xenial):
status: New → Fix Committed
Changed in gnome-software (Ubuntu Artful):
status: New → Fix Released
Changed in gnome-software (Ubuntu Bionic):
status: Fix Committed → Fix Released
importance: High → Undecided
Changed in gnome-software (Ubuntu Xenial):
importance: Undecided → High
Evan (ev) wrote :

Thanks for digging into this, Robert.

Hello Evan, or anyone else affected,

Accepted gnome-software into xenial-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/gnome-software/3.20.5-0ubuntu0.16.04.11 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed.Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested and change the tag from verification-needed-xenial to verification-done-xenial. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-xenial. In either case, without details of your testing we will not be able to proceed.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

tags: added: verification-needed verification-needed-xenial
Jean-Baptiste Lallement (jibel) wrote :

SRU verification for Xenial:
I have reproduced the problem with gnome-software 3.20.5-0ubuntu0.16.04.10 in xenial-updates and have verified that the version of gnome-software 3.20.5-0ubuntu0.16.04.11 in -proposed fixes the issue.

Marking as verification-done

tags: added: verification-done verification-done-xenial
removed: verification-needed verification-needed-xenial
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package gnome-software - 3.20.5-0ubuntu0.16.04.11

---------------
gnome-software (3.20.5-0ubuntu0.16.04.11) xenial; urgency=medium

  * debian/patches/0019-Support-channels.patch:
    - Make snap channel selection list scrollable (LP: #1768779)
  * debian/patches/0020-Add-a-basic-permission-system.patch
  * debian/patches/0021-Add-a-Snap-plugin.patch
    - Correctly handle snap install/remove failures (LP: #1762427)
    - Fix snaps without icons not showing (LP: #1763736)
    - Add basic system for connecting/disconnecting snap interfaces
      (LP: #1597314)
    - Alphabetically sort channel branch names (LP: #1769556)
  * debian/patches/0050-snap-Support-channels.patch:
    - Fix incorrect default install version being shown (LP: #1767445)

 -- Robert Ancell <email address hidden> Tue, 08 May 2018 12:02:36 +1200

Changed in gnome-software (Ubuntu Xenial):
status: Fix Committed → Fix Released

The verification of the Stable Release Update for gnome-software has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers